Functions
Peripheral State and Errors Functions
Peripheral Driver » HAL Driver » ADC » Functions

ADC control functions. More...

## Functions
hal_adc_state_t | hal_adc_get_state (adc_handle_t *p_adc)
| Return the ADC handle state. More...
uint32_t | hal_adc_get_error (adc_handle_t *p_adc)
| Return the ADC error code. More...
void | hal_adc_suspend_reg (adc_handle_t *p_adc)
| Suspend some registers related to ADC configuration before sleep. More...
void | hal_adc_resume_reg (adc_handle_t *p_adc)
| Restore some registers related to ADC configuration after sleep. This function must be used in conjunction with the hal_adc_suspend_reg(). More...
hal_pm_status_t | hal_pm_adc_suspend (adc_handle_t *p_adc)
| Suspend the specified ADC. More...
void | hal_pm_adc_resume (adc_handle_t *p_adc)
| Resume the specified ADC. More...
void | hal_adc_voltage_intern (adc_handle_t *p_adc, uint16_t *p_inbuf, double *p_outbuf, uint32_t buflen)
| Convert the ADC conversion results to a voltage value(internal reference). More...
void | hal_adc_voltage_extern (adc_handle_t *p_adc, double vref, uint16_t *p_inbuf, double *p_outbuf, uint32_t buflen)
| Convert the ADC conversion results to a voltage value(external reference). More...
void | hal_adc_temperature_conv (adc_handle_t *p_adc, uint16_t *p_inbuf, double *p_outbuf, uint32_t buflen)
| Convert the ADC conversion results to temperature value. More...
void | hal_adc_vbat_conv (adc_handle_t *p_adc, uint16_t *p_inbuf, double *p_outbuf, uint32_t buflen)
| Convert the ADC conversion results to battery value. More...

## Detailed Description

ADC control functions.

     ===============================================================================
                          ##### Peripheral State and Errors functions #####
     ===============================================================================
        [..]
        This subsection provides a set of functions allowing to control the ADC.
         (+) hal_adc_get_state() API can be helpful to check in run-time the state of the ADC peripheral.
         (+) hal_adc_get_error() check in run-time Errors occurring during communication.

## Function Documentation

## ◆ hal_adc_get_error()

uint32_t hal_adc_get_error | ( | adc_handle_t * | p_adc | ) |

Return the ADC error code.

Parameters

  [in] | p_adc | Pointer to an ADC handle which contains the configuration information for the specified ADC module.

Returns
  ADC error code in bitmap format

## ◆ hal_adc_get_state()

hal_adc_state_t hal_adc_get_state | ( | adc_handle_t * | p_adc | ) |

Return the ADC handle state.

Parameters

  [in] | p_adc | Pointer to an ADC handle which contains the configuration information for the specified ADC module.

Return values

  HAL_ADC_STATE_RESET | Peripheral not initialized.
  HAL_ADC_STATE_READY | Peripheral initialized and ready for use.
  HAL_ADC_STATE_BUSY | An internal process is ongoing.
  HAL_ADC_STATE_ERROR | Peripheral in error.

## ◆ hal_adc_resume_reg()

void hal_adc_resume_reg | ( | adc_handle_t * | p_adc | ) |

Restore some registers related to ADC configuration after sleep. This function must be used in conjunction with the hal_adc_suspend_reg().

Parameters

  [in] | p_adc | Pointer to a ADC handle which contains the configuration information for the specified ADC module.

Return values

  None |

## ◆ hal_adc_suspend_reg()

void hal_adc_suspend_reg | ( | adc_handle_t * | p_adc | ) |

Suspend some registers related to ADC configuration before sleep.

Parameters

  [in] | p_adc | Pointer to a ADC handle which contains the configuration information for the specified ADC module.

Return values

  None |

## ◆ hal_adc_temperature_conv()

void hal_adc_temperature_conv | ( | adc_handle_t * | p_adc,
|  | uint16_t * | p_inbuf,
|  | double * | p_outbuf,
|  | uint32_t | buflen
| ) |  |

Convert the ADC conversion results to temperature value.

Parameters

  [in] | p_adc | Pointer to a ADC handle which contains the configuration information for the specified ADC module.
  [in] | p_inbuf | Pointer to data buffer which storage ADC codes.
  [out] | p_outbuf | Pointer to data buffer which to storage conversion results.
  [in] | buflen | Length of data buffer.

Returns
  Result of operation.

## ◆ hal_adc_vbat_conv()

void hal_adc_vbat_conv | ( | adc_handle_t * | p_adc,
|  | uint16_t * | p_inbuf,
|  | double * | p_outbuf,
|  | uint32_t | buflen
| ) |  |

Convert the ADC conversion results to battery value.

Parameters

  [in] | p_adc | Pointer to a ADC handle which contains the configuration information for the specified ADC module.
  [in] | p_inbuf | Pointer to data buffer which storage ADC codes.
  [out] | p_outbuf | Pointer to data buffer which to storage conversion results.
  [in] | buflen | Length of data buffer.

Returns
  Result of operation.

## ◆ hal_adc_voltage_extern()

void hal_adc_voltage_extern | ( | adc_handle_t * | p_adc,
|  | double | vref,
|  | uint16_t * | p_inbuf,
|  | double * | p_outbuf,
|  | uint32_t | buflen
| ) |  |

Convert the ADC conversion results to a voltage value(external reference).

Parameters

  [in] | p_adc | Pointer to a ADC handle which contains the configuration information for the specified ADC module.
  [in] | vref | external reference value of ADC.
  [in] | p_inbuf | Pointer to data buffer which storage ADC conversion results.
  [out] | p_outbuf | Pointer to data buffer which to storage voltage results.
  [in] | buflen | Length of data buffer.

Returns
  Result of operation.

## ◆ hal_adc_voltage_intern()

void hal_adc_voltage_intern | ( | adc_handle_t * | p_adc,
|  | uint16_t * | p_inbuf,
|  | double * | p_outbuf,
|  | uint32_t | buflen
| ) |  |

Convert the ADC conversion results to a voltage value(internal reference).

Parameters

  [in] | p_adc | Pointer to a ADC handle which contains the configuration information for the specified ADC module.
  [in] | p_inbuf | Pointer to data buffer which storage ADC conversion results.
  [out] | p_outbuf | Pointer to data buffer which to storage voltage results.
  [in] | buflen | Length of data buffer.

Returns
  Result of operation.

## ◆ hal_pm_adc_resume()

void hal_pm_adc_resume | ( | adc_handle_t * | p_adc | ) |

Resume the specified ADC.

Parameters

  [in] | p_adc | Pointer to a ADC handle

Return values

  ::None |

## ◆ hal_pm_adc_suspend()

hal_pm_status_t hal_pm_adc_suspend | ( | adc_handle_t * | p_adc | ) |

Suspend the specified ADC.

Parameters

  [in] | p_adc | Pointer to a ADC handle

Return values

  HAL_PM_ACTIVE | Device is active, not allow sleep.
  HAL_PM_SLEEP | Allow sleep.